/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#include "ParserRegistration.h"


ParserRegistration* ParserRegistration::first = NULL;

void ParserRegistration::insert(ParserRegistration** prev, ParserRegistration* x)
{
	if ((*prev) == NULL || _stricmp((*prev)->name, x->name) != -1)
	{
		x->next = *prev;
		*prev = x;
	}
	else
		insert(&((*prev)->next), x);
}

ParserRegistration::ParserRegistration(ParserFunc f, const char* n)
{
	func = f;
	name = n;
//	next = first;
//	first = this;
	insert(&first, this);
}

int ParserRegistration::getNumParsers()
{
	int result = 0;
	for (ParserRegistration* p = first; p != NULL; p = p->next)
		result++;
	return result;
}

const char* ParserRegistration::getParserName(int i)
{
	int j;
	ParserRegistration* p = first;
	for (j = 0; j < i; j++)
		p = p->next;
	return p->name;
}

ParserRegistration::ParserFunc ParserRegistration::getParserFunc(int i)
{
	int j;
	ParserRegistration* p = first;
	for (j = 0; j < i; j++)
		p = p->next;
	return p->func;
}

// Author: Patrick Pelletier
