/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#ifndef MIDIATOR_H
#define MIDIATOR_H

#include "Rogus.h"
#include "err_and_warn.h"
namespace rogus
{

class Midiator {
	enum { system = 7 };
	char portname[32];
	void (*callback)(HMIDIIN, UINT, DWORD, DWORD, DWORD);
	HANDLE threadHandle;
	UINT threadID;
	HANDLE hCom;
	volatile bool stopflag;
	volatile bool open;
	volatile bool initialized;
	unsigned char running_status;
	int outport;
	static unsigned WINAPI threadMain(LPVOID);
	void comSetup();
	void inputloop();
	void setRts(int);
	void setDtr(int);
	bool output_open[4];
	void open_if_needed();
	void close_if_needed();

   err_and_warn *ewp;
public:
	UINT out_start;
	UINT in_start;
	Midiator(const char* comport, void (*func)(HMIDIIN, UINT, DWORD, DWORD, DWORD),err_and_warn*);
	~Midiator();
	static UINT numInputs() { return 1; }
	static UINT numOutputs() { return 4; }
	void getInputName(UINT n, char* s);
	void getOutputName(UINT n, char* s);
	void openInput(UINT n);
	void closeInput(UINT n);
	void openOutput(UINT n);
	void closeOutput(UINT n);
	void send(UINT n, DWORD p);
};
}
#endif

// Author: Patrick Pelletier
