/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#ifndef UTILARRAY_H
#define UTILARRAY_H

#include "basic_types.h"
#include <assert.h>
namespace rogus
{


template <class T>
class UtilArray
{
#ifndef min
	static uint4 min(uint4 a, uint4 b) { return ((a>b) ? b : a); }
#endif
	bool elements_match(T* x) const
   {
      for (uint4 i = 0; i < length; i++)
         if (!(p[i] == x[i])) return false;
      return true;
   }
protected:
	T* p;
public:
	const uint4 length;

   UtilArray(uint4 l) : length(l) { p = new T[(l < 1) ? 1 : l]; }

   ~UtilArray() { delete[] p; }

	UtilArray<T>& operator=(const UtilArray<T>& x)
   {
      for (uint4 i = 0; i < min(length, x.length); i++)
         p[i] = x.p[i];
      return *this;
   }

   bool operator==(const UtilArray<T>& x) const
      { return (length == x.length && elements_match(x.p)); }

   T& operator[](uint4 i) { assert (i < length); return p[i]; }
};
}
#endif
// Author: Patrick Pelletier
