/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#ifndef UTILPTR_H
#define UTILPTR_H

#include "basic_types.h"
#include <assert.h>
namespace rogus
{


#pragma warning( disable : 4702 )
// unreachable code: permanently disabled (no matching "default")
#pragma warning( disable : 4710 )
// function <blah> not expanded: permanently disabled (no matching "default")


// I'm not at all sure why this is necessary but without it UtilPtr won't compile
#ifndef NULL
#define NULL 0
#endif

template <class T>
class UtilPtr
{
	class RefCounter
	{
	public:
		T* p;
		int count;
		RefCounter(T* in_p) { count = 1; p = in_p; }
		~RefCounter() { delete p; }
	};
	RefCounter* rc;
	
	void inc() { if (rc)   rc->count++; }
	void dec() { if (rc) { rc->count--; if (rc->count==0) { delete rc; rc = NULL; } } }
	void setup(T* x) { rc = x ? new RefCounter(x) : NULL; }
public:
	UtilPtr()                    { rc = NULL; }
	UtilPtr(T* x)                { rc = NULL; operator=(x); }
	UtilPtr(const UtilPtr<T>& x) { rc = NULL; operator=(x); }
	~UtilPtr() { dec(); }
	UtilPtr<T>& operator=(const UtilPtr<T>& x) { dec(); rc = x.rc; inc(); return *this; }
	UtilPtr<T>& operator=(T* x)                { dec(); setup(x);         return *this; }
	bool operator==(const UtilPtr<T>& x) const { return (rc == x.rc); }
	bool operator==(T* x) const { if (rc) return (rc->p == x); else return (x == NULL); }
	T* operator->() const { if (!rc) return NULL; else {assert(rc->count > 0); return (rc->p);} }
	T& operator*() const { return *operator->(); }
	operator T*() const  { return  operator->(); }
};
}
#endif
// Author: Patrick Pelletier
