/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#ifndef CHANNELSTATE_H
#define CHANNELSTATE_H

#include "basic_types.h"
#include "MIDI_lib.h"

namespace rogus
{
class ChannelState {
public:
  uchar notes[256];
  uint2 control14[32];
  uchar control7[16];
  uchar program;
  uchar channelPressure;
  uint2 pitchBend;
  ChannelState();
  void update(const MidiMsg*);
  void change(const ChannelState*, ioref, int, void (*outfunc)(const MidiMsg&));
};

typedef UtilPtr<ChannelState> ChannelStatePtr;
}
#endif
// Author: Patrick Pelletier
