/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#ifndef MIDIFILTER_H
#define MIDIFILTER_H

#include "MIDI_lib.h"
#include "State.h"
#include "string.h"
namespace rogus
{


class MidiFilter {
protected:
	const char* identity;
	void (*ptr)(MidiMsg*, const MidiFilter*);
public:
	void filter(MidiMsg* m) const { ptr(m, this); }
	virtual void apply(State*) const = 0;
	virtual void unapply(State*) const = 0;
	const char* getIdentity() const { return identity; }
	bool operator==(const MidiFilter& f) { return (strcmp(identity, f.identity) == 0); }
};
}
#endif
// Author: Patrick Pelletier
