/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#include "Transposer.h"
namespace rogus
{


void Transposer::transpose(MidiMsg* m, const MidiFilter* f)
{
	const Transposer* t = (const Transposer*)f;
	if (m->msgt() == MidiMsg::note_on || m->msgt() == MidiMsg::note_off)
		m->set_key(m->key() + t->trans);
}

void Transposer::iterator1(ioref, int, ChannelStatePtr* e, void* x)
{
	if ((*e) == NULL)
		return;
	uchar* notes = (*e)->notes;
	int t = ((Transposer*)x)->trans;
	if (t > 0)
		for (int i = 255; i > -1; i--)
			notes[i] = (((i-t) > -1) ? notes[i-t] : notes[i-t+256]);
	else if (t < 0)
		for (int i = 0; i < 256; i++)
			notes[i] = (((i-t) < 256) ? notes[i-t] : notes[i-t-256]);
}

void Transposer::apply(State* s) const
{
	s->iterate(iterator1, (void*) this);
}

void Transposer::iterator2(ioref, int, ChannelStatePtr* e, void* x)
{
	if ((*e) == NULL)
		return;
	uchar* notes = (*e)->notes;
	int t = -((Transposer*)x)->trans;
	if (t > 0)
		for (int i = 255; i > -1; i--)
			notes[i] = (((i-t) > -1) ? notes[i-t] : notes[i-t+256]);
	else if (t < 0)
		for (int i = 0; i < 256; i++)
			notes[i] = (((i-t) < 256) ? notes[i-t] : notes[i-t-256]);
}

void Transposer::unapply(State* s) const
{
	s->iterate(iterator2, (void*) this);
}
}
// Author: Patrick Pelletier

